unit AMemo;
{
                                                                       12/15/00

   TAMemo is a simple way to make a TMemo truly readonly:
   no caret, no popup, no selection.

   You are allowed to use and alter this component as you like.
   Eberhard Beck, <eb@lettas.com>.


}

interface
uses windows, messages, sysutils, classes, controls, stdctrls, extctrls;

type
  TTransiP = class(TPanel)
  private
    { Private declarations }
    procedure   WMEraseBkgnd      ( var Message: TWMEraseBkgnd ); message WM_EraseBkgnd ;
    procedure   WMPaint           ( var Message: TWMPaint ) ;     message WM_Paint;
  protected
    procedure CreateParams(var Params: TCreateParams); override;
  public
    { Public declarations }
end;


type
  TAMemo = class(TMemo)
  private
    { Private declarations }
  protected
    procedure WndProc(var Message: TMessage); override;
    Procedure MakeReadOnly;
  public
    mTransi               : TTransiP;
  published
  end;

procedure Register;

implementation

procedure Register;
begin
   RegisterComponents('Samples', [TAMemo]);
end;

{==============================================================================}
{================================ TransiP =====================================}
{==============================================================================}

Procedure TTransiP.CreateParams (var params : TCreateParams);
Begin
  inherited CreateParams (params) ;
  Params.ExStyle := Params.ExStyle or WS_EX_TRANSPARENT;
End ;

procedure TTransiP.WMEraseBkgnd(var Message: TWMEraseBkgnd);
Begin
  Message.Result := 1;   // no further erasing required
end;

Procedure TTransiP.WMPaint(var Message: TWMPaint);
var aR : TRect;
Begin
  aR := Rect(0,0,clientwidth,clientheight);
  ValidateRect(handle,@aR);
  inherited;
end;

{==============================================================================}
{=============================== AMemo ========================================}
{==============================================================================}

Procedure TAMemo.MakeReadOnly;
Begin
  if assigned(mTransi) then exit;
  mTransi := TTransiP.create(self);
  mTransi.visible := false;
  mTransi.Parent := Parent;
  mTransi.SetBounds(Left,Top,width,Height);
  mTransi.visible := True;
  mTransi.SetFocus;
End;

procedure TAMemo.WndProc(var Message: TMessage);
begin
  if Message.Msg = WM_Paint then begin
    MakeReadOnly;
  end else
  if Message.Msg = WM_SIZE then begin
    if assigned(mTransi) then
      mTransi.SetBounds(Left,Top,width,Height);
  end else
  if Message.Msg = WM_SETFOCUS then begin
    if assigned(mTransi) then begin
      mTransi.SetFocus;
      Message.Result := 0;
      exit;
    end;
  end;
  inherited;
end;

end.
